/**
 * @package css-modules-types-loader
 * @license MIT
 * @version 0.2.0
 * @author undefined <undefined>
 * @description A webpack loader that dynamically generates TypeScript typings for CSS modules from css-loader.
 * @see https://github.com/nuintun/css-modules-types-loader#readme
 */

'use strict';

const threads = require('threads');
const utils = require('./utils.js');

/**
 * @module generate
 */
threads.expose(async function generate(path, content, options = {}) {
  const typings = utils.generateTypings(content, options.banner, options.eol);
  if (typings) {
    return utils.writeFile(path, typings);
  } else {
    return utils.removeFile(path);
  }
});
