/**
 * @package css-modules-types-loader
 * @license MIT
 * @version 0.2.0
 * @author undefined <undefined>
 * @description A webpack loader that dynamically generates TypeScript typings for CSS modules from css-loader.
 * @see https://github.com/nuintun/css-modules-types-loader#readme
 */

import { Pool, spawn, Worker } from 'threads';

/**
 * @module index
 */
const pool = Pool(() => {
  return spawn(new Worker('./generate'));
});
async function terminate(force) {
  return pool.terminate(force);
}
async function generate(path, content, options) {
  pool.queue(async generate => {
    await generate(path, content.toString(), options);
  });
  await pool.completed();
}

export { generate, terminate };
